#include <stdio.h>
#include <stdlib.h>

#include <sys/types.h>
#include <unistd.h>
#include <sys/ipc.h>
#include <sys/shm.h>

main(int argc, char **argv)
{
  int n, i;
  pid_t pid;
  double d, s, x, pi;

  double *shared;
  int shmid, iproc;

  if (argc != 2)
    n = 10;
  else
    n = atoi(argv[1]);

  d = 1.0/n;
  shmid = shmget(IPC_PRIVATE, 
                 sizeof(double), (IPC_CREAT | 0600));
  shared = shmat(shmid, 0, 0);
  shmctl (shmid, IPC_RMID, 0);

  iproc = 0;  
  if ((pid = fork()) == -1) {
    fprintf(stderr, "The fork failed!\n");
    exit (EXIT_FAILURE);
  } 
  else {
    if (pid != 0) 
      iproc = 1 ;
  }

  s = 0.0;
  for (i=iproc+1; i<=n; i+=2) {
    x = (i-0.5)*d;
    s += 4.0/(1.0+x*x);
  }

  pi = d*s;

  if (pid == 0) {
    *shared = pi;
    exit (EXIT_SUCCESS); 
  } 
  else { 
    wait(0); 
    pi = pi + *shared;
    fprintf ( stdout, "computed pi value = %.23f...\n", pi);
    fprintf ( stdout, "                    3.14159265358979323846264...\n");
  }

  return EXIT_SUCCESS;
}
